var feed_url;

function init_globals() {
    default_reload_interval = 20; // Minutes
    min_refresh_interval    = 10;

//    default_reload_interval = 2; // Minutes
//    min_refresh_interval    = 1;

    notify_interval = 5; // Seconds

    // Change this to 1 for displaying random clips
    // instead of latest clip.
    display_random  = 0;

    default_feed_url      = "http://mefeedia.com/feeds/new/mrss.xml";

    caption_url = "http://mefeedia.com";
    item_url    = "";
    vlog_url    = "http://freevlog.org";
    
    highlight_color = "#1111aa";
    
    mutedImage      = "Images/mute2.png";
    unMutedImage    = "Images/mute.png";

    feed_data       = "";
    feed_item       = 0;
    nfeeds          = 50;
    reload_timer    = 0;
    
    init_widget();
    load_settings();
}

function refresh_controls() {
    if (muted) {
        set_img(mute, mutedImage);
        set_tooltip(mute, "Sound Disabled");
    } else {
        set_img(mute, unMutedImage);
        set_tooltip(mute, "Sound Enabled");
    }

    update_prefs(false);
}

function refresh_display() {
    refresh_controls();
}

function get_tag (data, tag) {
    var re = new RegExp("<" + tag +  "[^>]*>(.*?)</" + tag + ">", "i");
    var m  = data.match(re);
    var array = new Array();

    if (m) {
        return m[1];
    }
}

function get_one_tag (data, tag) {
    var re  = new RegExp("<" + tag +  "[^>]*>(.*?)</" + tag + ">", "ig");
    var re1 = new RegExp("<" + tag +  "[^>]*>(.*?)</" + tag + ">", "i");
    var m   = data.match(re);

    if (m) {
        nfeeds  = m.length;
        var idx = feed_item;
        data1 = m[idx];
        m1 = data1.match(re1);
        if (m1) {
            return m1[1];
        }
    }

}

function get_random_tag (data, tag) {
    var re  = new RegExp("<" + tag +  "[^>]*>(.*?)</" + tag + ">", "ig");
    var re1 = new RegExp("<" + tag +  "[^>]*>(.*?)</" + tag + ">", "i");
    var m   = data.match(re);

    if (m) {
        var idx = Math.round( Math.random() * m.length - 0.5);
        data1 = m[idx];
        m1 = data1.match(re1);
        if (m1) {
            return m1[1];
        }
    }

}


function get_attrs(data, tag, attr) {
    var matcher = "<" + tag +  "[^>]*" + attr + "=\"(.*?)\"";
    var re2 = new RegExp(matcher + ".*?" + matcher, "i");
    var re1 = new RegExp(matcher, "i");

    var m  = data.match(re2);
    if (!m) {
        m  = data.match(re1);
    }

    return m;
}

function fit_string(data, length) {
    var fitstr1 = "";
    a = data.split(/ /g);
    for (i=0; i<a.length; i++) {
        if (fitstr1.length + a[i].length+1 < length) {
            fitstr1 = fitstr1 + " " + a[i];
        } else {
            break;
        }
    }

    return fitstr1;
}

function parse_data(data) {
    a = data.split(/\n/g);
    data = a.join(' ');

    var captionstr = get_tag(data, "title");
    caption_url    = get_tag(data, "link");

    var titleprefix="";

    if (1) {
        var item       = get_one_tag(data, "item");
    } else {
        var item       = get_tag(data, "item");
    }

    var titlestr   = unescape(get_tag(item, "title"));
    var descstr    = unescape(get_tag(item, "description"));
    item_url       = get_tag(item, "link");

    // Breakup description string into chunks that fit
    // into the 4 description lines.

    fitstr               = fit_string(descstr, 24);
    fitlen               = fitstr.length;
    set_text(item_desc1, fitstr);

    fitstr               = fit_string(descstr.substring(fitlen), 24);
    fitlen               += fitstr.length;
    set_text(item_desc2, fitstr);

    fitstr               = fit_string(descstr.substring(fitlen), 17);
    fitlen               += fitstr.length;
    set_text(item_desc3, fitstr);

    fitstr               = fit_string(descstr.substring(fitlen), 15);
    fitlen               += fitstr.length;
    set_text(item_desc4, fitstr);
    
    set_text(caption, captionstr.substring(0,3));
    set_text(item_title, fit_string(titlestr, 17));
}

function feed_loaded(data) {
    if (feed_data != data) {
        feed_item = 0;
    }

    parse_data(data);

    if (feed_data != data) {
        notify();
    }
    feed_data = data;
}

function show_loading() {
    set_text(item_title, "Loading ...");
}

function mute_enter() {
    set_opacity(mute, "60");
}

function mute_exit() {
    set_opacity(mute, "100");
}

function flip_mute() {
    muted = bool_not(muted);

    save_settings();
    load_settings();
}

// Scroll through the feeds

function next_clip() {
    if (feed_item < nfeeds-1) {
        feed_item++;
        parse_data(feed_data);
    }
}

function prev_clip() {
    if (feed_item > 0) {
        feed_item--;
        parse_data(feed_data);
    }
}

// Highlighting and Linking elements
function caption_enter() {
    set_color(caption, "#333333");
    set_opacity(img_heart,80);
    set_opacity(static_heart1,80);
    set_opacity(static_heart2,80);
    set_opacity(static_heart3,80);
}

function caption_exit() {
    set_color(caption,"#000000");
    set_opacity(img_heart,"100");
    set_opacity(static_heart1,"100");
    set_opacity(static_heart2,"100");
    set_opacity(static_heart3,"100");
}

function caption_click() {
    open_url(caption_url);
}

function desc_enter() {
    set_color(item_desc1,"#DDDB01");
    set_color(item_desc2,"#DDDB01");
    set_color(item_desc3,"#DDDB01");
    set_color(item_desc4,"#DDDB01");

    set_color(item_title,"#0DF2FF");
}

function desc_exit() {
    set_color(item_desc1,"#FFFD01");
    set_color(item_desc2,"#FFFD01");
    set_color(item_desc3,"#FFFD01");
    set_color(item_desc4,"#FFFD01");

    set_color(item_title,"#0DF2FF");
}

function desc_click() {
    open_url(item_url);
}


// Title
function title_enter() {
    set_color(item_title, "#0BD2DD");
}

function title_exit() {
    set_color(item_title, "#0DF2FF");
}

function title_click() {
    open_url(item_url);
}

// Free Vlog Icon
function freevlog_enter() {
    set_opacity(static_freevlog,80);
    set_opacity(start_your_own,80);
}

function freevlog_exit() {
    set_opacity(static_freevlog,"100");
    set_opacity(start_your_own,"100");
}

function freevlog_click() {
    open_url(vlog_url);
}

function star_enter() {
    set_opacity(img_star,80);
    set_opacity(static_star1,80);
    set_opacity(static_star2,80);
    set_opacity(static_star3,80);
    set_opacity(static_star4,80);
    set_opacity(static_star5,80);
}

function star_exit() {
    set_opacity(img_star,"100");
    set_opacity(static_star1,"100");
    set_opacity(static_star2,"100");
    set_opacity(static_star3,"100");
    set_opacity(static_star4,"100");
    set_opacity(static_star5,"100");
}

function star_click() {
    open_url(item_url);
}

function save_settings() {
    set_setting("feedurl", feed_url);
    set_setting("muted", muted);
}

function load_settings() {
    if (!get_setting("feedurl")) {
        set_setting("feedurl", default_feed_url);
    }

    if (!get_setting("refresh")) {
        set_setting("refresh", default_reload_interval);
    }
    if (get_setting("refresh") < min_refresh_interval) {
        set_setting("refresh", min_refresh_interval);
    }

    feed_url = get_setting("feedurl");
    muted = get_setting("muted");
    curr_reload_timer = get_setting("refresh");

    refresh_controls();
}

function prefs_changed() {
    var reload = 0;
    var old_reload_timer = curr_reload_timer;

    if (feed_url != get_setting("feedurl")) {
        reload = 1;
    }

    load_settings();

    if (old_reload_timer != curr_reload_timer) {
        reload = 1;
    }

    if (reload) {
        show_loading();
        reload_feed();
    }

    refresh_display();
}

function onLoad() {
    init_globals();

    refresh_display();
    set_visible(main, true);

    show_loading();
    reload_feed();
}

